/****************************************************************************
* COSC2138/CPT220 - Programming Principles 2A
* Study Period 2  2010 Assignment #1 - battleship program
* Full Name        : Brad Mccormack
* Student Number   : s3258798
* Yallara Username : s3258798 ?
* Course Code      : COSC2138
* Program Code     : EDIT HERE
* Start up code provided by the CTeach team
****************************************************************************/

/* Header files. */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <ctype.h>

/* Constants. */
#define SIZE 10
#define CELLS SIZE*SIZE
#define SHIPS_TO_SINK 3
#define HIT 'x'
#define MISS '='
#define UNKNOWN ' '
#define TRUE 1
#define FALSE 0

#define AIRCRAFT_CARRIER 'A'
#define BATTLESHIP 'B'
#define DESTROYER 'D'
#define FRIGATE 'F'
#define SUBMARINE 'S'

#define AIRCRAFT_CARRIER_LEN 5
#define BATTLESHIP_LEN 4
#define DESTROYER_LEN 3
#define FRIGATE_LEN 3
#define SUBMARINE_LEN 2


/*Brads custom defines*/
#define LOWERCASEA 97
#define LOWERCASEJ 106
#define ASCII0 48
#define ASCII9 57
#define PLAYERDELIM '|'
#define NUMSHIPS 5
#define HORIZONTAL 1
#define VERTICAL 2

/*Search values for AI*/
#define UP 0
#define RIGHT 1
#define DOWN 2
#define LEFT 3

/*Attack modes for AI*/
#define SEARCH 0
#define NEAREST 1
#define ATTACK 2



#define PROMPT_LENGTH 80
#define TRUE 1
#define FALSE 0
#define SUCCESS 1
#define FAILURE 0
#define TEMP_STRING_LENGTH 5

/* Function prototypes. */
void init(char playerHidden[SIZE][SIZE], char playerReveal[SIZE][SIZE],
          char computHidden[SIZE][SIZE], char computReveal[SIZE][SIZE]);
void placePlayerShips(char playerHidden[SIZE][SIZE]);
void placeComputerShips(char computHidden[SIZE][SIZE]);
void displayKnownInfo(char playerReveal[SIZE][SIZE],
                      char playerHidden[SIZE][SIZE],
                      char computReveal[SIZE][SIZE]);
void playerGuess(char computHidden[SIZE][SIZE],
                 char computReveal[SIZE][SIZE]);
void computerGuess(char playerHidden[SIZE][SIZE],
                   char playerReveal[SIZE][SIZE]);
int isGameOver(char playerHidden[SIZE][SIZE], char playerReveal[SIZE][SIZE],
               char computHidden[SIZE][SIZE], char computReveal[SIZE][SIZE]);
void displayAllInfo(char playerHidden[SIZE][SIZE],
                    char playerReveal[SIZE][SIZE],
                    char computHidden[SIZE][SIZE],
                    char computReveal[SIZE][SIZE]);
void readRestOfLine();


void renderGrids(char* gridleft,char* gridright,int gridsize);
void readRestOfLine();
int getString(char* string, unsigned length, unsigned minlength,char* prompt);
int tolower(int c);
void showKnown(char hidden[SIZE][SIZE],char shown[SIZE][SIZE],char shipType);
int getSunkShips(char grid[SIZE][SIZE]);
void revealHidden(char hiddengrid[SIZE][SIZE],char displayedgrid[SIZE][SIZE]);
void getValidCell(char* guess);
int isOverlap(int shipSize,char *grid,char *cellref,int direction,
              int showError);
void refTexttoCellIndex(char* guess);
void assignFinalValidCells(char shipType,int shipLength,
                           char* shipName,char*grid);
void fillCells(char shipType,int shipLength,char* cellref,char* grid,
               int direction);
void assignFinalValidComputerCells(char shipType,int shipLength,char* grid);

struct shipRecord
{
  unsigned int ahits;
  unsigned int bhits;
  unsigned int dhits;
  unsigned int fhits;
  unsigned int shits;
};

struct AI
{
  unsigned int attackmode;
  unsigned int currentdirection;
  unsigned int founddirection;
  unsigned int hitrow;
  unsigned int hitcol;
  unsigned int row;
  unsigned int col;
  unsigned int attackcount;
};
